package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.HousingTrust;
import com.izouma.awesomeadmin.service.HousingTrustService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/housingTrust")
public class HousingTrustController extends BaseController{

    @Autowired
    private HousingTrustService housingTrustService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(HousingTrust record) {
        List<HousingTrust> pp = housingTrustService.getHousingTrustList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getHousingTrust", method = RequestMethod.GET)
    @ResponseBody
    public Result getHousingTrust(@RequestParam(required = false, value = "id") String id) {
        HousingTrust data = housingTrustService.getHousingTrustById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(HousingTrust record) {
        HousingTrust data = housingTrustService.getHousingTrust(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, HousingTrust record) {
        Map<String, Object> result = new HashMap<>();

        List<HousingTrust> pp =housingTrustService.getHousingTrustByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(HousingTrust record) {
        boolean num = housingTrustService.createHousingTrust(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateHousingTrust(HousingTrust record) {
        boolean num = housingTrustService.updateHousingTrust(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteHousingTrust(@RequestParam(required = true, value = "id") String id) {

        boolean num = housingTrustService.deleteHousingTrust(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, HousingTrust record) throws Exception {

    List<HousingTrust> housingTrusts = housingTrustService.getHousingTrustList(record);


        String sheetName = "housing_trust";
        String titleName = "房屋托管 数据表";
        String fileName = "房屋托管 表";
        int columnNumber = 11;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  " id" ,   "删除标识" ,   "用户ID" ,   "用户名" ,   "姓名" ,   "联系电话" ,   "地址区域" ,   "详细地址" ,   "备注" ,   "时间" ,   "状态"  };
        String[][] dataList = new String[housingTrusts.size()][11];

        for (int i = 0; i < housingTrusts.size(); i++) {

                        dataList[i][0] = String.valueOf(housingTrusts.get(i).getId());
                        dataList[i][1] = String.valueOf(housingTrusts.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(housingTrusts.get(i).getUserId());
                        dataList[i][3] = String.valueOf(housingTrusts.get(i).getUserName());
                        dataList[i][4] = String.valueOf(housingTrusts.get(i).getRealName());
                        dataList[i][5] = String.valueOf(housingTrusts.get(i).getTelephone());
                        dataList[i][6] = String.valueOf(housingTrusts.get(i).getAddress());
                        dataList[i][7] = String.valueOf(housingTrusts.get(i).getAddressDetail());
                        dataList[i][8] = String.valueOf(housingTrusts.get(i).getRemark());
                        dataList[i][9] = String.valueOf(housingTrusts.get(i).getCreateTime());
                        dataList[i][10] = String.valueOf(housingTrusts.get(i).getStatusFlag());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

